#!/usr/local/bin/ruby
#nDiary on the Web
# sessionɂpX[hF
# tgA̓tftHgAҏWփN
# Lt@ČƈꗗAҏWփN
# t@CΓǍAȂ΋󔒁AҏW{^ŏ
#  <>ieƍ폜j
# XVAIvVw
#  <>iIvVs̑Ώj
# XVy[W
#  <>i10b҂ōŐVLy[W֒ԁj

require 'webframe'
require 'find'
require 'kconv'
require 'tempfile'

ONDIARY_INTERFACE_VERSION = 'interface v.20040204'

class WebFrame < WebFrameSeed

  def initialize ( config = nil, mode = nil )
    super
    
    @menu = ['input', 'list', 'upload', '|', 'enikkilist', 'enikkiup', '|', 'update', '|', 'diary']
    
    @password         = ''
    @script_directory = '.'
    @log_directory    = '.'
    @output_directory = '.'
    @image_directory  = '.'
    @latest_filename  = 'index.html'
    @max_image_size   = 12800
    @fileKcode        = 2    #= 'EUC'  #1('JIS'),2('EUC'),3('SJIS')
    @fileRETcode      = "\n" #= 'UNIX' #1('UNIX')("\n"),2('DOS')("\r\n"),3('MAC')("\r")
    @password         = PASSWORD         if defined?(PASSWORD)
    @mode_escape      = ESCAPE_HTML      if defined?(ESCAPE_HTML)
    @script_directory = SCRIPT_DIRECTORY if defined?(SCRIPT_DIRECTORY)
    @log_directory    = LOG_DIRECTORY    if defined?(LOG_DIRECTORY)
    @output_directory = OUTPUT_DIRECTORY if defined?(OUTPUT_DIRECTORY)
    @image_directory  = IMAGE_DIRECTORY  if defined?(IMAGE_DIRECTORY)
    @latest_filename  = LASTEST_FILENAME if defined?(LASTEST_FILENAME)
    @max_image_size   = MAX_IMAGE_SIZE   if defined?(MAX_IMAGE_SIZE)
    @list_size        = defined?(LIST_SIZE) ? LIST_SIZE : 100
    outdir = @output_directory
    outdir += '/' if @output_directory !~ /\/$/
    @diaryfile = outdir + @latest_filename
    @diaryfile = @latest_filename if @latest_filename =~ /^http:\/\//
    
    @txtarea_height = defined?(TXTAREA_HEIGHT) ? TXTAREA_HEIGHT : 30
    @txtarea_width  = defined?(TXTAREA_WIDTH)  ? TXTAREA_WIDTH  : 80
    @option         = defined?(DEFAULT_OPTION) ? DEFAULT_OPTION : ''
    @diary_filemode = defined?(DIARY_FILEMODE) ? DIARY_FILEMODE : nil
    @diary_template = defined?(DIARY_TEMPLATE) ? DIARY_TEMPLATE : nil
    @diary_datetime = defined?(DIARY_DATETIME) ? DIARY_DATETIME : nil
    @flag_nulldiarydelete = defined?(FLAG_NULLDIARYDELETE) ? FLAG_NULLDIARYDELETE : true
    
    @flag_dirdiarysave = defined?(FLAG_DIRDIARYSAVE)
    @editable_dir   = defined?(EDITABLE_DIR) ? EDITABLE_DIR : []
    @editable_ext   = defined?(EDITABLE_EXT) ? EDITABLE_EXT : []
    if defined?(FILEKCODE) #ۑR[h
      case FILEKCODE
      when 1, /^JIS$/i;  @fileKcode = 1
      when 2, /^EUC$/i;  @fileKcode = 2
      when 3, /^SJIS$/i; @fileKcode = 3
      end
    end
    if defined?(FILERETCODE) #ۑsR[h
      case FILERETCODE
      when 1, /^UNIX$/i; @fileRETcode = "\n"
      when 2, /^DOS$/i;  @fileRETcode = "\r\n"
      when 3, /^MAC$/i;  @fileRETcode = "\r"
      else @fileRETcode = FILERETCODE
      end
    end
    @script_url = 'http://' + ENV['REMOTE_HOST'].to_s + ENV['REQUEST_URI'].to_s if @script_url == '' #REMOTE_HOST = REMOTE_ADDR ?
    
    begin
      cmd_select
    rescue Exception
      message = [$!]
      $@.each{ |l| message << l }
      @message = message.join("<br>\n")
      cmd_error
    end
  end

#========== jump ========== ========== ==========
  def cmd_select
    pass_check            #x ̂RgAEgŁA
    if @pass != @password #x pX[hFȂȂ܂
      cmd_login           #x
    else                  #x ̑̕Ήend
      @cmd = @cgi.params['cmd'].first
      if !@cmd.nil? && (@cmd.type != String)
        @cmd = @cmd.read
      end
      case @cmd
      when 'index'
        cmd_index
      when 'list'
        cmd_list
      when 'input'
        cmd_input
      when 'upload'
        cmd_upload
      when 'update'
        cmd_update
      when 'enikkilist'
        cmd_enikkilist
      when 'enikkiup'
        cmd_enikkiup
      when 'save'
        cmd_save
      when 'exec'
        cmd_exec
      when 'diary'
        cmd_diary
      when 'edit'
        cmd_edit
      when 'enikkisave'
        cmd_enikkisave
      when 'jump_diary'
        cmd_jump_diary
      else
        cmd_index
      end
    end                   #x
  end

  def menu_index ( menu )
    menu_list = []
    menu.each{ |name|
      case name
      when 'index'
        menu_list << '<a href="' + @script_name + '">[index]</a>'
      when 'list'
        menu_list << '<a href="' + @script_name + '?cmd=list">[list]</a>'
      when 'input'
        menu_list << '<a href="' + @script_name + '?cmd=input">[input]</a>'
      when 'upload'
        menu_list << '<a href="' + @script_name + '?cmd=upload">[upload]</a>'
      when 'update'
        menu_list << '<a href="' + @script_name + '?cmd=update">[update]</a>'
      when 'enikkilist'
        menu_list << '<a href="' + @script_name + '?cmd=enikkilist">[enikkilist]</a>'
      when 'enikkiup'
        menu_list << '<a href="' + @script_name + '?cmd=enikkiup">[enikkiup]</a>'
      when 'save'
        menu_list << '<a href="' + @script_name + '?cmd=save">[save]</a>'
      when 'exec'
        menu_list << '<a href="' + @script_name + '?cmd=exec">[exec]</a>'
      when 'diary'
        menu_list << '<a href="' + @script_name + '?cmd=diary">[diary]</a>'
      when 'top'
        menu_list << '<a href="index.html">[top]</a>'
      else
        menu_list << name
      end
    }
    return menu_list
  end

#========== login ========== ========== ==========
  def cmd_login
    @title = 'onDiary; login'
    menu = @menu
    @head_html = head_html(menu)
    @body_html = <<-END
<p>
<form action="#{@script_name}" method="post">
password? :
<input type="password" size="8" name="pass">
<input type="submit" value="login">
</form>
</p>
<hr width="50%" align="left" />
<p>
Ƃ肠pX[h͂ĉB<br />
config.txtŒ`̂łB<br />
</p>
    END
    html_page
  end

#========== index ========== ========== ==========
  def cmd_index
    cmd_input
  end

  def cmd_list
    list = []
    Find.find(@log_directory){ |file|
      if file =~ /\/(\d{8})(\.diary|\.dia)$/i
        list << [$1, file, File.mtime(file), File.size(file)]
      end
    }
    list.sort!{ |x,y| x.first <=> y.first}
    list.reverse!
    
    addlist = []
    dirs = []
    dirs << @log_directory
    dirs << @editable_dir
    dirs.flatten.each{ |dir|
      Find.find(dir){ |file|
        @editable_ext.each{ |ext|
          if file =~ /\.#{ext}$/i
            addlist << [file, file, File.mtime(file), File.size(file)]
          end
        }
      }
    }
    addlist.sort!{ |x,y| x.first <=> y.first}
    list += addlist
    
    listheader_str = ''
    if list.size > @list_size
      listheader = []
      page = @cgi.params['p'].first.to_i || 0
      maxpage = (list.size.to_f / @list_size.to_f).ceil - 1
      page = maxpage + page if page < 0
      listheader << %Q|<a href="#{@script_name}\?cmd=list">[s]</a>| if page > 1
      listheader << %Q|<a href="#{@script_name}\?cmd=list&p=#{page-1}">[]</a>| if page > 0
      listheader << %Q|[#{page}]|
      listheader << %Q|<a href="#{@script_name}\?cmd=list&p=#{page+1}">[]</a>| if page < maxpage
      listheader << %Q|<a href="#{@script_name}\?cmd=list&p=#{maxpage}">[t]</a>| if page < maxpage-1
      listheader_str = '<div class="bar_left">' + listheader.join + '</div>'
      s, e = page * @list_size, (page+1) * @list_size
      e = list.size if e > list.size
      list = list[s...e]
    end
    
    if @cgi.has_key?('download')
      @header = { "type" => "text/plain", "charset" => "Shift_JIS" }
      list.each{ |line| line[2] = line[2].to_i }
      str = ''
      list.each{ |line| str << line.join("\t") + "\n" }
      @cgi.out(@header){ str }
      exit
    end
    
    liststr = [['file', 'time', 'size']]
    list.each{ |date, file, time, size|
      time = time.strftime("%Y/%m/%d %H:%M:%S")
      liststr << ["<a href=\"#{@script_name}\?cmd=edit&file=#{file}\">#{date}<\/a>", time, size]
    }
    
    dumstr =  ''
    str = table_writer(dumstr, liststr, 50)
    
    @title = 'onDiary; list'
    menu = menu_replace(@menu, 'list', '[list]')
    @head_html = head_html(menu)
    @body_html = <<-END
<p>
#{listheader_str}
#{str}
</p>
<hr width="50%" align="left">
<p>
config.txtŎw肵OtH_ȉ猩Ă.diaryt@C̈ꗗłB<br />
iyconfig.txtŎw肵ҏW\tH_ȉ猩ĂҏW\gqt@C̈ꗗłBj<br />
Ctit@CjNbNŕҏWɒт܂B<br />
Lt@C_E[h́AuENbNۑv炢ł肢܂B<br />
</p>
    END
    html_page
  end

  def cmd_input
    date = (Time.now - (@diary_datetime.to_i * 3600)).strftime("%Y%m%d")
    logdir = @log_directory
    logdir += '/' if logdir !~ /\/$/
    
    @title = 'onDiary; input'
    menu = menu_replace(@menu, 'input', '[input]')
    @head_html = head_html(menu)
    @body_html = <<-END
<p>
<form action="#{@script_name}" method="post">
#{logdir}<input type="text" size="10" name="date" value="#{date}">.diary<br />
<input type="hidden" name="cmd" value="edit">
<input type="submit" value="edit">
</form>
</p>
<hr width="50%" align="left">
<p>
ҏW.diaryt@C̎włB<br />
Ƃ肠tĂ܂Bedit{^ŕҏWɒт܂B<br />
ߋt.diaryt@C肽EҏWȂAłݒedit{^ĂB<br />
iG[`FbNĂȂ̂ŁApSpƂ󔒂ƂO~XƂCāj<br />
ɂLҏWȂAチj[[list]ňꗗo܂B<br />
</p>
    END
    html_page
  end

  def cmd_upload
    date = Time.now.strftime("%Y%m%d")
    logdir = @log_directory
    logdir += '/' if logdir !~ /\/$/
    
    @title = 'onDiary; upload'
    menu = menu_replace(@menu, 'upload', '[upload]')
    @head_html = head_html(menu)
    @body_html = <<-END
<p>
<form action="#{@script_name}" method="post" enctype="multipart/form-data">
[from]: <input type="file" name="uploaded_file"><br />
[to  ]: #{logdir}<input type="text" size="10" name="date" value="#{date}">.diary<br />
<input type="hidden" name="cmd" value="edit">
<input type="submit" value="upload">
</form>
</p>
<hr width="50%" align="left">
<p>
Abv[ht@C̎wƁA<br />
̃T[oł̕ۑt@Ci.diaryt@Cj̎włB<br />
Ƃ肠tĂ܂Bupload{^ŕҏWɒт܂B<br />
iŉ߂save{^ŕۑĂj<br />
iG[`FbNĂȂ̂ŁApSpƂ󔒂ƂO~XƂCāj<br />
</p>
    END
    html_page
  end

  def cmd_enikkilist
    list = []
    Find.find(@image_directory){ |file|
      if file =~ /(\.jpg|\.jpeg|\.gif|\.png|\.bmp|\.tiff)$/i
        list << [$1, file, File.mtime(file), File.size(file)]
      end
    }
    list.sort!{ |x,y| x.first <=> y.first}
    
    if @cgi.has_key?('download')
      @header = { "type" => "text/plain", "charset" => "Shift_JIS" }
      list.each{ |line| line[2] = line[2].to_i }
      str = ''
      list.each{ |line| str << line.join("\t") + "\n" }
      @cgi.out(@header){ str }
      exit
    end
    
    liststr = [['file', 'time', 'size']]
    list.each{ |date, file, time, size|
      time = time.strftime("%Y/%m/%d %H:%M:%S")
      liststr << ["<a href=\"#{file}\">#{file}<\/a>", time, size]
    }
    
    dumstr =  ''
    str = table_writer(dumstr, liststr, 50)
    
    @title = 'onDiary; enikkilist'
    menu = menu_replace(@menu, 'enikkilist', '[enikkilist]')
    @head_html = head_html(menu)
    @body_html = <<-END
<p>
#{str}
</p>
<hr width="50%" align="left">
<p>
config.txtŎw肵摜tH_ȉ猩Ă摜t@C̈ꗗłB<br />
</p>
    END
    html_page
  end

  def cmd_enikkiup
    date = Time.now.strftime("%Y%m%d")
    imgdir = @image_directory
    imgdir += '/' if imgdir !~ /\/$/
    
    @title = 'onDiary; enikkiup'
    menu = menu_replace(@menu, 'enikkiup', '[enikkiup]')
    @head_html = head_html(menu)
    @body_html = <<-END
<p>
<form action="#{@script_name}" method="post" enctype="multipart/form-data">
[from]: <input type="file" name="uploaded_file"><br />
[to  ]: #{imgdir}<input type="text" size="15" name="file" value="#{date+'.jpg'}"><br />
<input type="hidden" name="cmd" value="enikkisave">
<input type="submit" value="upload">
</form>
</p>
<hr width="50%" align="left">
<p>
Abv[ht@C̎wƁA<br />
̃T[oł̕ۑt@C̎włB<br />
Ƃ肠tĂ܂B<br />
iG[`FbNĂȂ̂ŁApSpƂ󔒂ƂO~XƂCāj<br />
</p>
    END
    html_page
  end

  def cmd_save
    file = @cgi.params['file'].first.to_s.strip
    text = @cgi.params['text'].first.to_s.strip
    cmd_single if @cgi.has_key?('single')
    
    text = diary_save(file, text)
    
    @title = 'onDiary; save'
    menu = @menu
    @head_html = head_html(menu)
    @body_html = <<-END
<p>
#{file}
</p>
<p>
<pre>
#{text}
</pre>
</p>
<p>
<a href="#{@script_name}?cmd=update">update</a>
</p>
<hr width="50%" align="left">
<p>
.diaryt@CۑmFB<br />
ȏ̃t@CEeŕۑ܂Bi͍폜܂Bj<br />
update{^œLɒт܂B<br />
ʓt.diaryt@CҏŴłA[input][list]ŕҏWɖ߂ĂB<br />
</p>
    END
    html_page
  end

  def cmd_update
    @title = 'onDiary; update'
    menu = menu_replace(@menu, 'update', '[update]')
    @head_html = head_html(menu)
    @body_html = <<-END
<p>
<form action="#{@script_name}" method="post">
ruby diary <input type="text" size="20" name="option" value="#{@option}"><br />
<input type="hidden" name="cmd" value="exec">
<input type="submit" value="exec">
</form>
</p>
<hr width="50%" align="left">
<p>
nDiary̎sB<br />
nDiarỹIvVAKvłłłB<br />
IvV΍ŐVLƁAɊ܂܂t܂މߋL̐A<br/>
IvVu200101vȂ2001N1L̐Â͂łB<br />
exec{^nDiarys܂B<br />
</p>
    END
    html_page
  end

  def cmd_exec
    option = @cgi.params['option'].first.to_s.strip
    
    message = diary_exec(option)
    
    @title = 'onDiary; save'
    menu = @menu
    @head_html = head_html(menu)
    @body_html = <<-END
<p>
<pre>
#{message}
</pre>
</p>
<p>
<a href="#{@script_name}?cmd=jump_diary">diary</a>
</p>
<hr width="50%" align="left">
<p>
nDiary̎smFB<br />
ȂDOSɗ郁bZ[WɏoĂ܂B<br/>
diaryNŐLɒт܂B<br />
iLhtml̍ŐVԕ\\ɂ́A[hKv܂j<br />
</p>
    END
    html_page
  end

  def cmd_diary
    @title = 'onDiary; diary'
    menu = menu_replace(@menu, 'diary', '[diary]')
    @head_html = head_html(menu)
    @body_html = <<-END
<p>
<a href="#{@script_name}?cmd=jump_diary">diary</a>
</p>
<hr width="50%" align="left">
<p>
diaryNŐLɒт܂B<br />
iLhtml̍ŐVԕ\\ɂ́A[hKv܂j<br />
</p>
    END
    html_page
  end

  def cmd_jump_diary
    @cgi.out( 'Location' => @diaryfile ){ '' }
  end

  def cmd_single
    file = @cgi.params['file'].first.to_s.strip
    text = @cgi.params['text'].first.to_s.strip
    option = @cgi.params['option'].first.to_s.strip
    option = @option unless @cgi.has_key?('option')
    
    diary_save(file, text)
    message = diary_exec(option)
    
    @title = 'onDiary; single'
    menu = @menu
    @head_html = head_html(menu)
    @body_html = <<-END
<p>
<pre>
#{message}
</pre>
</p>
<p>
<a href="#{@script_name}?cmd=jump_diary">diary</a>
</p>
<hr width="50%" align="left">
<p>
nDiary̎smFB<br />
ȂDOSɗ郁bZ[WɏoĂ܂B<br/>
diaryNŐLɒт܂B<br />
</p>
    END
    html_page
  end

  def cmd_edit
    file = @cgi.params['file'].first.to_s.strip
    date = @cgi.params['date'].first.to_s.strip
    date = @cgi.params['date'].first.read if @cgi.has_key?('uploaded_file')
    date = Time.now.strftime("%Y%m%d") if date == ''
    if file == ''
      file = date + '.diary'
      logdir = @log_directory
      logdir += '/' if logdir !~ /\/$/
      if @flag_dirdiarysave                   #[hɓĂA
        if file =~ /^\d{8}\./                 #t݂̂̃t@C
          dir1, dir2 = file[0..3], file[4..5] #Ndirƌdir쐬A
          file = "#{dir1}/#{dir2}/#{file}"    #̉diaryۑ
          Dir.mkdir("#{logdir}#{dir1}") unless FileTest.exist?("#{logdir}/#{dir1}")
          Dir.mkdir("#{logdir}#{dir1}/#{dir2}") unless FileTest.exist?("#{logdir}#{dir1}/#{dir2}")
        end
      end
      file = logdir + file
    end
    #ȒPȓ͐B
    ex_file   = File.expand_path(file)
    #@log_directoryȉłȂꍇA͂B
    #@editable_dirȉłȂꍇA͂B
    flag = true
    dirs = []
    dirs << @log_directory
    dirs << @editable_dir
    dirs.flatten.each{ |d| flag = false if ex_file =~ /^#{File.expand_path(d)}/ }
    cmd_input if flag
    #tłȂꍇA͂B
    #@editable_extłȂꍇA͂B
    flag = true
    flag = false if file =~ /\/(\d{8})(\.diary|\.dia)$/i
    @editable_ext.each{ |e| flag = false if ex_file =~ /\.#{e}$/ }
    cmd_input if flag
    
    text = ''
    text = open(file).read if FileTest.exist?(file)
    text = CGI.unescapeHTML(text) if @mode_escape #HTML^Oނ̕ϊ
    text = @cgi.params['uploaded_file'].first.read if @cgi.has_key?('uploaded_file')
    text = open(@diary_template).read if text == '' && !@diary_template.nil?
    
    if @cgi.has_key?('download')
      @header = { "type" => "text/plain", "charset" => "Shift_JIS" }
      @cgi.out(@header){ text }
      exit
    end
    if @cgi.has_key?('upload')
      diary_save(file, text)
      @header = { "type" => "text/plain", "charset" => "Shift_JIS" }
      @cgi.out(@header){ 'message: save ok.' }
      exit
    end
    
    @title = 'onDiary; edit'
    menu = @menu
    @head_html = head_html(menu)
    @body_html = <<-END
<p>
#{file}
</p>
<p>
<form action="#{@script_name}" method="post">
<input type="hidden" name="file" value="#{file}">
<textarea cols="#{@txtarea_width}" rows="#{@txtarea_height}" name="text">#{text}</textarea><br />
<input type="hidden" name="cmd" value="save">
<input type="submit" value="save">
<input type="checkbox" name="single">ꔭH
</form>
</p>
<hr width="50%" align="left">
<p>
.diaryt@CiȂwݒt@CjҏWĂB<br />
iҏWĂt@CɏoĂ܂j<br />
save{^ۑłB<br />
ݒɂ܂Ag̃t@C͍폜܂B<br />
uꔭHv`FbNƂƁACɓL܂Œт܂B<br />
FȂ񂾂ꔭ̒qłBLۑ͐Ă̂ŁAʓr[update]xƂƐ܂BsB<br />
</p>
    END
    html_page
  end

  def cmd_enikkisave
    file = @cgi.params['file'].first.read
    cmd_enikkiup unless @cgi.has_key?('uploaded_file')
    imgdir = @image_directory
    imgdir += '/' if imgdir !~ /\/$/
    file = imgdir + file
    #ȒPȓ͐B@img_directoryłȂꍇA摜gqłȂꍇA͂B
    ex_imgdir = File.expand_path(@image_directory)
    ex_file   = File.expand_path(file)
    cmd_enikkiup if ex_file !~ /^#{ex_imgdir}/
    cmd_enikkiup if file !~ /(\.jpg|\.jpeg|\.gif|\.png|\.bmp|\.tiff)$/i
#    cmd_input if file !~ /\/(\d{8})\.$/i
    #GLptt@C܂ł͗vȂȁH
    
    image = @cgi.params['uploaded_file'].first.read
    cmd_enikkiup if image.size == 0
    if image.size > @max_image_size
      @message = "t@CTCY#{@max_image_size}ȏ̂̂͋֎~Ă܂B(#{image.size})"
      cmd_error
    end
    image_save(file, image)
    
    @title = 'onDiary; enikkisave'
    menu = @menu
    @head_html = head_html(menu)
    @body_html = <<-END
<p>
<br />
#{file}<br />
</p>
<p>
<a href="#{@script_name}?cmd=update">update</a>
</p>
<hr width="50%" align="left">
<p>
摜t@CA<br />
ȏ̃t@CEeŕۑ܂BƎv܂B<br />
update{^œLɒт܂B<br />
ʂ̉摜t@CUP̂łA[enikkiup]ɖ߂ĂB<br />
</p>
    END
#{@cgi.params['file'].first.path}<br />
    html_page
  end

#========== engine ========== ========== ==========
  def diary_save ( file, text )
    text.gsub!(/@@@@/,"\t")
    newtext = ''
    text.each{ |line|
      newtext << line.kconv(@fileKcode).chomp.chomp("\r") + @fileRETcode
    }
    text = newtext
    text = CGI.escapeHTML(text) if @mode_escape #HTML^Oނ̕ϊ
    open(file, 'wb').write(text) #sR[h̕ϊȂbin-modeŕۑ
    File.chmod(@diary_filemode, file) unless @diary_filemode.nil?
    if @flag_nulldiarydelete
      File.delete(file) if text.strip == ''
    end
    return text
  end

  def image_save ( file, image )
    open(file, 'wb').write(image)
    File.chmod(0644, file)
    File.chmod(@diary_filemode, file) unless @diary_filemode.nil?
    if @flag_nulldiarydelete
      File.delete(file) if image.size == 0
    end
  end

  def diary_exec ( option )
    File.umask(0022) #html-filepfile-modeύX
    Dir.chdir(@script_directory)
    $KCODE = 'SJIS'  #nDiary{̗pchar-codeSJISɕύX
    file = 'message.txt'
    fp = Tempfile.open(file)
    if RUBY_VERSION =~ /^1.8/
      $stdout = $stderr = fp #F$stdout͕svH
    else
      $defout = $stderr = fp #F$stdout͕svH
    end
    argstr = 'diary'
    exefile = argstr 
    exefile = File.readlink(argstr) if FileTest.symlink?(argstr)
    dir = File.dirname(exefile)
    Dir.chdir(dir)
    $: << dir
    require 'ndiary-lib.rb'
    require 'ndiary-custom.rb'
    argv = option.split
    begin
      main(argv)
    rescue Exception
      fp.write $!
    end
    if RUBY_VERSION =~ /^1.8/
      $stdout, $stderr = STDOUT, STDERR #F$stdout=STDOUTw肷error
    else
      $defout, $stderr = STDOUT, STDERR #F$stdout=STDOUTw肷error
    end
    fp.close
    fp.open
    message = Kconv.toeuc(fp.read) #HHH̑̕ΉsHHH
    fp.close(true)                 #HHHCGIgSJISɂ̋HHH
    $KCODE = 'SJIS'   #CGIpchar-codeEUCɕύX
    File.umask(0066) #session-filepfile-modeύX
    return message
  end

#========== perts ========== ========== ==========
  def table_writer (fp, data, step = 0)
    step = data.size if step == 0
    size = data.size
    str = ''
    0.step(size-1, step){ |i|
      j =  i + step - 1
      j = -1 if j >= size
      str << '<table border="1">' + "\n"
      data[i..j].each{ |line|
        str << '<tr><td>' + line.join('</td><td>') + '</td></tr>' + "\n"
      }
      str <<  '</table>' + "\n"
    }
    if fp.type == (IO||File)
      fp.print str
    end
    return str
  end

#========== message ========== ========== ==========
  def cmd_error
    @title = 'G[Fs܂B'
    @message = '' if @message.nil?
    menu = @menu
    @head_html = head_html(menu)
    @body_html = <<-END
<p>
<h3>#{@title}</h3>
</p>
<p>
#{@message}
</p>
<p>
#{$!}
</p>
<p>
q̃bZ[Wŕs̗Rł傤H<br />
Ήꍇ́AǗl
<a href="http://ippo.s5.xrea.com"></a>
(<a href="mailto:ippo@geocities.co.jp">mail</a>,
<a href="http://146.teacup.com/ippo/bbs">BBS</a>)
ɌA肢܂B<br />
</p>
    END
    html_page
  end

#===== html ===== =====
  def head_html( menu )
    menu_list = menu_index(menu)
    str = <<-END
<table bgcolor="##{@titlecolor}" width="100%">
<tr>
<td align="left">
#{menu_list.join("\n")}
</td>
</tr>
</table>
    END
    if @script_url =~ /^http:\/\/ippo.s5.xrea.com/ #ł̍L
      banner = <<-END
<div align="right">
<iframe height="60" width="468" title="ad" frameborder="0" marginheight="0" marginwidth="0" scrolling="no" src="http://ad.xrea.com/ad_iframe.fcg?site=ippo.s5.xrea.com"><a href="http://ad.xrea.com/ad_click.fcg?site=ippo.x5.xrea.com" target="_blank"><img src="http://ad.xrea.com/ad_img.fcg?site=ippo.x5.xrea.com" height="60" width="468" border="0" alt="ad"></a></iframe>
</div>
      END
      str = banner + str
    end
    return str
  end

  def tail_html
    @tail_html = <<-END
<table bgcolor="##{@titlecolor}" width="100%"><tr><td align="right">
#{ONDIARY_INTERFACE_VERSION} |
<a href="http://ippo.s5.xrea.com"></a>
(<a href="mailto:ippo@geocities.co.jp">mail</a>,
<a href="http://146.teacup.com/ippo/bbs">BBS</a>) |
<a href="http://www.ruby-lang.org/ja/">Ruby</a> /
<a href="http://www14.cds.ne.jp/~not/product/ndiary/">nDiary</a>
<a href="http://ippo.s5.xrea.com/x/ondiary/">on the Web</a> |
<a href="index.html">[index]</a> /
<a href="../">[up]</a>
</td></tr></table>
    END
    return @tail_html
  end
end

WebFrame.new('./config.txt') #ݒt@C̎wŋN
