# 2003/11/04 C
=begin
  (filter/)sum_price_x.rb
    nDiary Filter  ƌvIl̍쐬
    z.pricet@C𐶐܂B
    plugin/sum_price_x.rbƂ킹ėpAȂʂ̏WvvOƗpB
    format:
      .priset@C1s1ATAB؂
      date, anchor, title, type, code, price
      8t, LAJ[, i, i^(book,cd), ^(ISBN), i
      ȏŏ\Ǝv̂łB
=end

class Filter
  BOOKSTORE = Regexp::compile(/[\(i]ISBN(\d-[\d-]{9}-\w)[\)j]/) unless defined?(BOOKSTORE)
  BOOKSTOREX = Regexp::compile(/[\(i]ISBN[:|F]?\s?(\d-[\d-]{9}[-]?[\w]?)[\)j]/)  unless defined?(BOOKSTOREX)
  #BOOKSTOREbookstorȅʃRp`̐K\̂͂B
  AMAZON    = Regexp::compile(/[\(i]amz:(\d-[\d-]{9}-\w)[\)j]/)
  PRICETAG  = Regexp::compile(/<!--Tag:price:(.*?)-->/)
  #ex) <!--Tag:price:title=title:type=CD:\2000-->

  def sum_price_x(str, type)
    return unless @diary.kind_of?(PastDiary)
    unless @flag_initial_sum_price_x #initialize
      #-----CX^Xϐi@vaulej𑽗pĂ̂ŁA-----
      #-----ȉbookstore_xƏdE㏑ݒLBӁB-----
      @flag_initial_sum_price_x = true
      @cache_base_dir = @diary.config['CACHE_DIRECTORY'] || @diary.logDirectory.chomp('/') + '/bookcache'
      @cache_base_dir.chomp!('/')
      @expire = @diary.config['CACHE_EXPIRE'] || 12
      @flag_net = @diary.config['nonet']
      @filename = @diary.logDirectory + @diary.targetMonth + '.price'
      File.delete(@filename) if File.exist?(@filename)
      @flag_tag = true
      @flag_bookstore_x = true #JEgΏۂbookstore_x
      @flag_amazon = false     #JEgΏۂamazonɁAeXg
      @flag_bookstore = false  #JEgΏۂbookstoreɁA
      @shop_list   = @diary.config['BOOKSTORE_SHOP_LIST'].to_s   unless defined?(@shop_list)
      @shop_list0  = @diary.config['BOOKSTORE_SHOP_LIST_0'].to_s unless defined?(@shop_list0)
      @shop_list1  = @diary.config['BOOKSTORE_SHOP_LIST_1'].to_s unless defined?(@shop_list1)
      @shop_list   = 'amazon bk1 yahoo asahiya jbook kinokuniya rakuten skysoft' if @shop_list.empty?
      @shop_list0 = 'amazon amazon.com skysoft a1books powells kinokuniya maruzen' if @shop_list0.empty?
      @shop_list1 = 'amazon_uk bookshop' if @shop_list1.empty?
      if @flag_bookstore_x
        #-----eʂ̊ɍ킹ēK-----RRJ-----
        require '../user/lib/cookie'     #K{Ewebagentp
        require '../user/lib/webagent'   #K{Ewebagentp
        require '../user/lib/cache'      #K{ELbVp
        require '../user/lib/amazon'     #ȉ͊eXpEsvȏX͍폜
        require '../user/lib/bk1'
#        require '../user/lib/yahoo' #?
#        require '../user/lib/asahiya'
#        require '../user/lib/jbook'
#        require '../user/lib/kinokuniya'
#        require '../user/lib/rakuten'
#        require '../user/lib/skysoft'
#        require '../user/lib/amazon_com' #?
#        require '../user/lib/a1books' #?
#        require '../user/lib/powells' #?
#        require '../user/lib/maruzen' #?
#        require '../user/lib/amazon_co_uk' #?
#        require '../user/lib/bookshop' #?
#        require '../user/lib/esbooks'
#        require '../user/lib/boople' #???
#        require '../user/lib/rcom'
#        require '../user/lib/rl' #?
#        require 'filter/amazon' # amazonJEg
        #-----̕ۑtH_̎w-----
        @cache_dir = {} if @cache_dir.nil? 
        @cache_dir['amazon']     = "#{@cache_base_dir}/amz"
        @cache_dir['bk1']        = "#{@cache_base_dir}/bk1"
        @cache_dir['yahoo']      = "#{@cache_base_dir}/yho"
        @cache_dir['asahiya']    = "#{@cache_base_dir}/ash"
        @cache_dir['jbook']      = "#{@cache_base_dir}/jbk"
        @cache_dir['kinokuniya'] = "#{@cache_base_dir}/kin"
        @cache_dir['rakuten']    = "#{@cache_base_dir}/rak"
        @cache_dir['skysoft']    = "#{@cache_base_dir}/sky"
        @cache_dir['amazon_com'] = "#{@cache_base_dir}/amc"
        @cache_dir['a1books']    = "#{@cache_base_dir}/a1b"
        @cache_dir['powells']    = "#{@cache_base_dir}/pwl"
        @cache_dir['maruzen']    = "#{@cache_base_dir}/mrz"
        @cache_dir['amazon_uk']  = "#{@cache_base_dir}/amu"
        @cache_dir['bookshop']   = "#{@cache_base_dir}/bsp"
        @cache_dir['esbooks']    = "#{@cache_base_dir}/esb"
        @cache_dir['boople']     = "#{@cache_base_dir}/bpl"
        @cache_dir['rcom']       = "#{@cache_base_dir}/rcm"
        #-----eʂ̊ɍ킹ēK-----RR}f-----
      end
    end
    
    filename = @diary.logDirectory + @diary.targetMonth + '.price'
    if filename != @filename
      @filename = filename
      File.delete(@filename) if File.exist?(@filename)
    end
    
    case type
    when :P, :DL, :UL
      list = []
      #-----tag search-----
      str.scan(PRICETAG){
        str = $1
        title, type, code, price = '', '', '', ''
        str.split(/:/).each{ |word|
          tag, val = word.split(/=/)
          case tag
          when 'title'
            title = val
          when 'type'
            type = val
          when 'code'
            code = val
          when 'price'
            price = val
          end
          price = tag if tag =~ /^\\|/
          price = price.gsub(/[\\||,|~|iŔj]/,'').strip
        }
        list << [title, type, code, price]
      } if @flag_tag
      #-----ISBN search (for bookstore.rb)-----
      str.scan(BOOKSTORE){
        isbn = $1
        #chache -> price ?
        title, type, price = '', 'book', ''
        list << [title, type, isbn, price]
      } if @flag_bookstore
      #-----ISBN search (for bookstore_x.rb)-----
      str.scan(BOOKSTOREX){
        isbn1 = $1
        isbn2 = isbn1.delete('-')
        checkbook = CacheBib.new()
        newisbn = checkbook.isbn_check(isbn1)
        isbn1 = newisbn
        info = {}
        @bookstore_list = @shop_list.split(/\s+/)
        @bookstore_list = @shop_list0.split(/\s+/) if isbn2 =~ /^0/
        @bookstore_list = @shop_list1.split(/\s+/) if isbn2 =~ /^1/
        infolist = [] #-----XɃlbgڑ/LbV-----
        @bookstore_list.each{ |bookstore| infolist << nil }
        @bookstore_list.each_index{ |i|
          bookstore = @bookstore_list[i]
          book, info = nil, infolist[i]
#          next if flag_overload || (info['expire'] < @expire)
          begin
            case bookstore
            when 'amazon'
              book = CacheBib_amazon.new()
            when 'bk1'
              book = CacheBib_bk1.new()
            when 'yahoo'
              book = CacheBib_yahoo.new()
            when 'asahiya'
              book = CacheBib_asahiya.new()
            when 'jbook'
              book = CacheBib_jbook.new()
            when 'kinokuniya'
              book = CacheBib_kinokuniya.new()
            when 'rakuten'
              book = CacheBib_rakuten.new()
            when 'skysoft'
              book = CacheBib_skysoft.new()
            when 'amazon_com'
              book = CacheBib_amazon_com.new()
            when 'a1books'
              book = CacheBib_a1books.new()
            when 'powells'
              book = CacheBib_powells.new()
            when 'maruzen'
              book = CacheBib_maruzen.new()
            when 'amazon_uk'
              book = CacheBib_amazon_uk.new()
            when 'bookshop'
              book = CacheBib_bookshop.new()
            when 'esbooks'
              book = CacheBib_esbooks.new()
            when 'boople'
              book = CacheBib_boople.new()
            when 'rcom'
              book = CacheBib_rcom.new()
            when 'reviewlink'
              next
            else
              $stderr.puts "WAR; unknown-bookstore; code:#{bookstore}"
              next
            end
          rescue Exception
            $stderr.puts "WAR; access-error; #{isbn1} - #{@bookstore_name[bookstore]}"
            next
          end
          book.expire = @expire
          flag_net = @flag_net
          #lbgւ̐ڑ𐧌ȂႦΈȉ̗lɁB
          #flag_net = true if bookstore == 'amazon'
          book.cache_dir = @cache_dir[bookstore]
          info = book.get_data(isbn1, flag_net)
          infolist[i] = info
        }
        infolist.delete(nil)
        info = checkbook.merge_info( infolist )
        title, type, isbn, price = info['title'], 'book', isbn1, info['price']
        price = price.to_s.gsub(/[\\||,|~|iŔj]/,'').strip
        list << [title, type, isbn, price]
      } if @flag_bookstore_x
      #-----ASIN search (for amazon.rb)-----
      str.scan(AMAZON){
        isbn = $1
        amz = Amazon::new
        amz.cache_dir = @diary.logDirectory + 'amzcache'
        amz.isbn = isbn
        if @diary.respond_to?('config') then
          amz.expire = @diary.config['AMAZON_EXPIRE'] || 7
          amz.proxy = @diary.config['PROXY']
        end
        title, type, price = amz.title, 'book', amz.price
        price = price.gsub(/[\\||,|~|iŔj]/,'').strip
        list << [title, type, isbn, price]
      } if @flag_amazon
      #-----list-----
      unless list.empty?
        anchor = ''
        if @diary.paragraphAnchor
          if @diary.anchorEachTopic
            anchor = "_t#{@diary.instance_eval{@cntTopic}}_#{@diary.instance_eval{@cntParagraph + 1}}"
          else
            anchor = "_#{@diary.instance_eval{@cntParagraph + 1}}"
          end
        end
        anchor = "#{@diary.date2monthlyfilelink(@diary.date, true)}#{anchor}"
        open(@filename, 'a'){ |fp|
          list.each{ |line|
#            line.unshift(anchor)
#            line.unshift(@diary.date)
#            fp.puts line.join("\t")
            fp.puts [@diary.date, anchor, *line].join("\t")
            #o̓tH[}bgdate,anchor,title,type,code,priceTAB؂
          }
        }
      end
    end
  end
end
