=begin
  (plugin/)sum_price_x.rb
    nDiary Plug-in  ƌvIl̍쐬
    .pricet@CɕtꂽKv܂B
    option:
      list=on         ꗗ\܂B
      total=on        S.pricet@Cv܂B
      month=on        list=on,total=onŎgpAʕ\sꍇłB
      default=val     lisɉZlݒ肵܂B(w莞500)
      filter=on       codeISBNƌ􂵂ďCAFilterʂ܂B
                      list,totalƂ͋܂񂵁Adefault͖ӖɂȂ܂B
    format:
      .priset@C1s1ATAB؂
      date, anchor, title, type, code, price
      8t, LAJ[, i, i^(book,cd), ^(ISBN), i
      ȏŏ\Ǝv̂łB
    note:
      ŁA\`Eiʂ̏Wv͓KĉB
    exsample:
      <!--plug=sum_price_x?list=on-->
    reference:
      http://www.ruby-lang.org/ja/man-1.6/index.cgi?cmd=view;name=%C0%B5%B5%AC%C9%BD%B8%BD#a.a5.b5.a5.f3.a5.d7.a5.eb
    update:
      2003.11.4
=end

class String
  def to_yen
    newstr, count = '', 0
    newstr = self.gsub(/(\d)((?:\d\d\d)+\b)/, '\1,\2')
    newstr = '\\' + newstr
    return newstr
  end
end

def plug(opt)
  default_price = 500
  if opt.has_key?('default')
    default_price = opt['default'].to_i
  end
  filelist = []
  if opt['total'] == 'on'
    #@logDirectoryT΂̂ŁAC
    Dir::find(@logDirectory){ |file|
      next unless /\/\d{6}\.price$/i =~ file
      filelist << file
    }
  else
    if self.kind_of?(LastDiary) or self.kind_of?(Topics) then
      thismonth = @diaries[0][0..5]
    elsif self.kind_of?(PastDiary) then
      thismonth = @targetMonth
#    else
#      return
    end
    filelist << @logDirectory + thismonth + '.price'
  end
  price, size, list = 0, 0, []
  filelist.each{ |file|
    lines = File.exists?(file) ? open(file).readlines : []
    lines.each{ |line|
      data = line.chomp.split("\t")
      #f[^̏
      #date, anchor, title, type, code, price = line.split("\t")
      val = data[-1].to_i
      val = default_price if (val == 0) && (data[-1] !~ /0/)
      data[-1] = val
      price += val
      list << data
    }
    size += lines.size
  }
  str = ''
  yearmonth, price2, num = '', 0, 0
  #Ƃ͌h悭Ƃ
  if opt['list'] == 'on'
    list.each{ |line|
      date, anchor, title, type, code, price1 = line
      if opt['month'] == 'on'
        if yearmonth != date[0..5]
          if yearmonth != ''
            str << '<tr><td>' + ['', '', price2.to_s.to_yen + '~(' + num.to_s + ')'].join('</td><td>') + '</td></tr>'
            str << "<\/table>\n\n"
          end
          str << "<h2>#{Time::local(date[0..3], date[4..5]).strftime2('%YN%m')}</h2>\n\n"
          str << '<table class="price">'
          yearmonth = date[0..5]
          price2, num = 0, 0
        end
      end
      if yearmonth == ''
        str << '<table class="price">'
        yearmonth = 'off'
      end
      if date =~ /(\d\d\d\d)(\d\d)(\d\d)/
        datestr = "#{$1.to_i.to_s}\/#{$2.to_i.to_s}\/#{$3.to_i.to_s}"
      end
      str << '<tr><td>' + ["<a href=\"#{anchor}\">#{datestr}<\/a>", title, price1.to_s.to_yen].join('</td><td>') + '</td></tr>'
      price2 += price1.to_i
      num += 1
    }
    if opt['month'] == 'on'
      str << '<tr><td>' + ['', '', price2.to_s.to_yen + '~(' + num.to_s + ')'].join('</td><td>') + '</td></tr>'
      str << "<\/table>\n\n"
      str << "<h2>v</h2>\n\n"
      str << '<table class="price">'
    end
    str << '<tr><td>' + ['', '', price.to_s.to_yen + '~(' + size.to_s + ')'].join('</td><td>') + '</td></tr>'
    str << '</table>'
  else
    str << '<div class="price">'
    str << price.to_s.to_yen + '~(' + size.to_s + ')'
    str << '</div>'
  end
  if opt['filter'] == 'on'
    str = ''
    list.each{ |line|
      date, anchor, title, type, code, price1 = line
      bookstr = '(ISBN' + code + ')'
      @filter.bookstore_x(bookstr, :P)
      if date =~ /(\d\d\d\d)(\d\d)(\d\d)/
        datestr = "#{$1.to_i.to_s}\/#{$2.to_i.to_s}\/#{$3.to_i.to_s}"
      end
      str << "<h4 class=\"price\"><a href=\"#{anchor}\"> #{datestr}<\/a>: " + title + '</h4>'
      str << bookstr.gsub(/\n/,"<br />\n")
    }
  end
  return str
end
