#!/usr/local/bin/ruby
# review-link
# 2003.2.6  ver0.1  by ippo from hate.rb ver0.1
# 2003.2.8  ver0.2  by ippo
# 2003.2.22 ver0.3  by ippo
# 2003.3.11 ver0.3m by ippo Version.MARIA
# 2003.5.6  ver0.4  by ippo rename webframe
# 2003.5.13 ver0.5  by ippo @cgi
# 2004.1.20 ver0.6  by ippo config, exit

LIBVERSION = '0.5'

require 'cgi'
require 'cgi/session'
require 'kconv'

class WebFrameSeed
  attr_accessor :configfile

#===== initial ===== =====
  def initialize ( config = nil, mode = nil )
    @version = LIBVERSION
    @cgi = CGI::new("html4Tr")
    File.umask(0066) # åեïˤɤޤ줿ʤ
    @session = CGI::Session::new( @cgi ) # åϤ롣
    @cmd = @cgi['cmd'].first || 'index'
    @header = { "type" => "text/html", "charset" => "euc-jp" }
    @script_name  = ENV['SCRIPT_NAME'].to_s
    @http_referer = ENV['HTTP_REFERER'].to_s
    
    @def_guestname = 'guest'
    @def_bgcolor   = '3'
    @bgcolor_table = ['ffffff','dddddd','ffeeee','eeffee','eeeeff','ffffdd','ddffff','ffddff']
    @bgcolor = @session['bgcolor'] || @bgcolor_table[@def_bgcolor.to_i]
    @titlecolor  = 'aaffaa'
    @title2color = 'ccffcc'
    
    @configfile = 'config.txt'
    @configfile = config unless config.nil?
    load(@configfile) if @configfile.to_s != ''
    
=begin
    begin
      cmd_select
    rescue Exception
      @message = $!
      cmd_error
    end
=end
  end

#===== parts ===== =====
  def e(s)
    CGI::escapeHTML(s)
  end

#===== session ===== =====
  def name_check
    @name = @session['name'] # åǡФ
    if @name.to_s == ''
      @name = @def_guestname
    end
    return @name
  end

  def pass_check
    @pass = @session['pass'] # åǡФ
    if @cgi.has_key?('pass')
      @pass = @cgi['pass'].first.to_s
      @session['pass'] = @pass
    end
    return @pass
  end

  def mode_check
    @mode = @session['mode'] # åǡФ
    if @cgi.has_key?('mode')
      @mode = @cgi['mode'].first
      @session['mode'] = @mode
    end
    return @mode
  end

  def sort_check
    @sort = @session['sort'] # åǡФ
    if @cgi.has_key?('sort')
      @sort = @cgi['sort'].first
      @session['sort'] = @sort
    end
    return @sort
  end


#========== jump ========== ========== ==========
  def cmd_select
    @cmd = @cgi['cmd'].first || 'index'
    case @cmd
    when 'error'
      cmd_error
    end
    cmd_index
  end

#========== index ========== ========== ==========
  def cmd_index
    @title = 'index'
    menu = menu_replace(@menu, 'index')
    @head_html = head_html(menu)
    @body_html = <<-END
<h1>#{@title}</h1>
<p>
index
</p>
    END
    html_page
  end

#========== message ========== ========== ==========
  def cmd_error
    @title = '顼Զ礬ȯޤ'
    @message = '' if @message.nil?
    menu = @menu
    @head_html = head_html(menu)
    @body_html = <<-END
<p>
<h3>#{@title}</h3>
</p>
<p>
#{@message}
</p>
<p>
#{$!}
</p>
<p>
ҤΥåԶͳȽǤ礦<br />
б񤷤ϡͤ˸Ϣꤤޤ<br />
</p>
    END
    html_page
  end

  def cmd_message
    name_check
    cmd_error if @message.nil?
    @title = 'message'
    @message = '' if @message.nil?
    menu = @menu
    @head_html = head_html(menu)
    @body_html = <<-END
<p>
<h3>#{@title}</h3>
</p>
<p>
#{@message}
</p>
    END
    html_page
  end

#===== html ===== =====

=begin
  def html_page
    @cgi.out( @header ) {
      <<-END
<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN" "http://www.w3.org/TR/html4/loose.dtd">
<html lang="ja">
<head>
<title>#{@title}</title>
</head>
<body bgcolor="##{@bgcolor}">
#{@head_html}
#{@body_html}
#{tail_html}
</body>
</html>
      END
    }
#    exit
  end
=end

  def html_page
    @cgi.out(@header){
      @cgi.html("lang"=>"ja"){ "\n" +
        @cgi.head(){ "\n" + @cgi.title{@title} + "\n" } + "\n" +
        @cgi.body("bgcolor"=>"##{@bgcolor}"){
          <<-END

#{@head_html}
#{@body_html}
#{tail_html}
          END
        } + "\n"
      }
    }
#    exit
  end

  def menu_replace(menu, str, str2 = nil)
    str2 = '[' + str + ']' if str2.nil?
    menu.each_index{ |i| menu[i] = str2 if menu[i] == str }
    return menu
  end

  def menu_index ( menu )
    menu_list = []
    menu.each{ |name|
#      if name == 'loginout'
#        name = (@name == @def_guestname) ? 'login' : 'logout'
#      end
      case name
      when 'index'
        menu_list << '<a href="' + @script_name + '">[index]</a>'
      when 'top'
        menu_list << '<a href="index.html">[top]</a>'
      when 'up'
        menu_list << '<a href="../index.html">[up]</a>'
      else
        menu_list << name
      end
    }
    return menu_list
  end

  def head_html( menu )
    menu_list = menu_index(menu)
    str = <<-END
<table bgcolor="##{@titlecolor}" width="100%">
<tr>
<td align="left">
#{menu_list.join("\n")}
</td>
</tr>
</table>
    END
    return str
  end

  def tail_html
    @tail_html = <<-END
<table bgcolor="##{@titlecolor}" width="100%">
<tr>
<td align="right">
<a href="http://www.ruby-lang.org/ja/">Ruby</a> |
<a href="index.html">[index]</a>
</td>
</tr>
</table>
    END
    return @tail_html
  end
end
