# inlineimage.rb̔h
# $Id: inlineimage.rb,v 1.3 2003/08/21 12:38:37 not Exp $
# 2003/11/04 C
=begin
    C[W̓\tB
    TCYȗƃTCY擾݂B̍ۉ摜TCY̎k
      (c160=@inlineimage_max_sizeȉ)sB
   u-nonetvIvVŃlbgsڑBiXɁu-onlocalvł̑łBj
    摜TCY擾Cu̕ύXił͕sׁjB
    alignɓn@inlineimage_class.keys̏ꍇA
      <div class=...></div>ň͂ށB<p>^Oς݁B
    摜ւ̃Nk摜(@thumb/ȉt@C)Œ񎦁A
      k摜͉摜̃TCYkĒ񎦁A
      k܂łTCỶ摜̎̓NȂB
      Ɏw肷鎖ŁAk摜̎wA邢̓NȂwsB
  usage:
    imageserver(./img/foo.jpg foo|bar)
      -> <div class="image"><a href="http://@imageserver/./img/foo.jpg"
          title="foo"><img src="http://@imageserver/./img/thumb/foo.jpg"
          alt="bar" width="60" height="20" /></a></div>
  reference:
    ATm http://www.mushline.com/junk/200309.html#d27_t2
    LU߂ http://aturust.com/topics/200309.html#26_t1
               http://aturust.com/topics/200310.html#03_t1
    waka   http://www.double-red.net/ndiary/200310.html#02_t2
               http://www.double-red.net/ndiary/200310.html#04_t1
=end

class Filter
  def imageserver(str, type)
    @imageserver = 'http://ippo.itbdns.com/image/'
    @inlineimage_max_size = 160 # 0Ő
    @inlineimage_class = @diary.config['CLASS_IMAGE'] || {'image'=>nil, 'imgsmall'=>'img-small', 'imglarge'=>'img-large'}
    @thumb_dir = 'thumb'
    
    case type
    when :P
      if str =~ /imageserver\(((?:https?:|\.)[^)]+)\)/i
        div, proxy, align = nil, nil, nil
        proxy = @diary.config['PROXY'] if @diary.respond_to?('config')
        str.gsub!(/imageserver\(((?:https?:|\.)[^)]+)\)/i){
          url, alt, size, align = $1.split(/ /)
          url_href, title = url.dup, nil
          if url =~ /(.+)\|(.*)/
            url, url_href = $1, $2
            url_href = nil if url_href.empty?
            flag_thumb = false
          else
            dir, file = File.split(url)
            url = "#{dir}/#{@thumb_dir}/#{file}"
            flag_thumb = true
          end
          begin
            file = url[0,1] == '.' ? @imageserver + url : url
            file = getFileStream(file, proxy) unless !flag_thumb && !size.nil?
            raise if file =~ /^<html>/mi || file.nil?
                  #lbgzŎ擾łȂꍇH
          rescue
            if flag_thumb
              url = url_href.dup
              begin
                file = url[0,1] == '.' ? @imageserver + url : url
                file = getFileStream(file, proxy) if size.nil?
              rescue
              end
            end
          end
          url      = (@imageserver + url).gsub(/\/\.\//,'/')      if url[0,1] == '.'
          url_href = (@imageserver + url_href).gsub(/\/\.\//,'/') if url_href[0,1] == '.'
          if alt =~ /(.*)\|(.*)/
            title, alt = $1, $2
          end
          alt = url if alt.nil?
          w, h = 0, 0
          if /^(\d+)x(\d+)$/ =~ "#{size}"
            w, h = $1.to_i, $2.to_i
          else
            require 'lib/imagesize'
#            require '../user/lib/image_size'
#            require './lib/image_size'
            #Wimagesize.rb͎XTCY̌RL
            #w, h = ImageSize::size(url) #H얢`FbN
            #WłȂimage_size.rbŃTCY̌v
#            begin
#              image = ImageSizeNew.new(file)
#              image = ImageSize.new(file)
#              w, h = image.get_width, image.get_height
              w, h = ImageSize::size(file)
#            rescue
#            end
            unless w.zero?
              l = w > h ? w : h
              scale = 1
              while ((l/scale) > @inlineimage_max_size) && (@inlineimage_max_size != 0)
                scale *= 2
              end
              w, h = w/scale, h/scale
              url_href = nil if (scale == 1) && (url == url_href)
            #else #擾łȂꍇ̏cw肷̂ȂÂ͂
            #  w, h = @inlineimage_max_size, @inlineimage_max_size
            end
          end
          div = nil
          align = 'image' if align.nil?
          if @inlineimage_class.keys.include?(align) #divp^O
            class_str = @inlineimage_class[align] || align
            div, align = '<div class="' + class_str + '">', nil
          end
          img = ''
          img << '</p>' + div                    unless div.nil?
          unless url_href.nil?
            img << %Q!<a href="#{url_href}"!
            img << %Q! title="#{title}"!         unless title.nil?
            img << '>'
          end
          img << %Q!<a href="#{url_href}">!      unless url_href.nil?
          img << %Q!<img src="#{url}"!
          img << %Q! alt="#{alt}"!               unless alt.nil?
#          img << %Q! title="#{title}"!           unless title.nil?
          img << %Q! width="#{w}" height="#{h}"! unless w.zero?
          img << %Q! align="#{align}"!           unless align.nil?
          img << (@diary.isXHTML ? ' />' : '>')
          img << '</a>'                          unless url_href.nil?
          img << '</div><p>'                     unless div.nil?
          img
        }
        #D݂Œǉ
        #if align.to_s.downcase == 'right' && /<br clear="all">$/ !~ str
        #  str.replace(str + '<br clear="all">')
        #end
#        return :THROUGH unless div.nil?
      end
    when :AFTER_P
      str.gsub!(/<p>\s*<\/p>/mi, "\n")
      str.gsub!(/<p>\s*<br\s?\/?>\s*<\/p>/mi, "\n")
    end
  end

  def getFileStream(url, proxy)
    if /^http/ =~ url
      return if @diary.config['nonet'] && !@diary.config['onlocal']
      $stderr.puts "CHK; access; #{url}"
      require 'net/http'
      domain, port = "", ""
      if url =~ /\/\/(.+?)(?:\/|$)/
        domain = $1.to_s
      end
      protocol = url.split(":").first + "://"
      path = url.gsub(Regexp.new(protocol + domain),"")
      if proxy
        proxy, port = proxy.split(':')
        port = port.to_i
      else
        proxy = port = nil
      end
      begin
        http = Net::HTTP::Proxy(proxy, port).new(domain, 80)
        if /1\.6/ =~ RUBY_VERSION
          file_info, = http.get2(path)
        else
          file_info = http.get(path)
        end
        if file_info.code == '302'
          path = file_info.header['location'].sub(Regexp.new(url), "")
          file_info = http.get(path)
        end
        return(file_info.response.body)
      rescue
#        return $!
        return nil
      end
    else
      open(url, "rb").read
    end
  end
end
