#bookstore_xcachebibnp
#KȃICX͂łȂAG[fȂx̊Ԃɍ킹

class CacheBib_temp
  attr_accessor :isbn, :affiliate_code
  attr_accessor :expire, :cache_dir

  def get_data ( isbn, flag_net = false )
    @isbn = isbn
    return {'isbn'=>@isbn}
  end

  def url_bibinfo
    return nil
  end

  def word_delivery
    return ['x', 'over']
  end
end

# ʏ

unless defined?(CacheBib_amazon)
  class CacheBib_amazon < CacheBib_temp
    def url_bibinfo
      return 'http://www.amazon.co.jp/exec/obidos/ASIN/' + @isbn.delete('-') + '/' + @affiliate_code.to_s + '/ref=nosim'
    end
  end
end

unless defined?(CacheBib_bk1)
  class CacheBib_bk1 < CacheBib_temp
    def url_bibinfo
      bk1_id = @affiliate_code.nil? ? '' : 'aid=' + @affiliate_code.to_s + '&amp;'
      return 'http://www.bk1.co.jp/cgi-bin/srch/srch_result_book.cgi?' + bk1_id + 'idx=3&amp;isbn=' + @isbn
    end
  end
end

unless defined?(CacheBib_yahoo)
  class CacheBib_yahoo < CacheBib_temp
    def url_bibinfo
      return 'http://books.yahoo.co.jp/bin/search_key?pp=3&p=' + @isbn
    end
  end
end

unless defined?(CacheBib_asahiya)
  class CacheBib_asahiya < CacheBib_temp
    def url_bibinfo
      return 'http://www.netdirect.co.jp/search/ISSSchDetail.asp?ISBN=' + @isbn.delete('-')
    end
  end
end

unless defined?(CacheBib_jbook)
  class CacheBib_jbook < CacheBib_temp
    def url_bibinfo
      return 'http://www.jbook.co.jp/product.asp?isbn=' + @isbn.delete('-')
    end
  end
end

unless defined?(CacheBib_kinokuniya)
  class CacheBib_kinokuniya < CacheBib_temp
    def url_bibinfo
      if @isbn =~ /^0/
        return 'http://bookweb.kinokuniya.co.jp/guest/cgi-bin/booksea.cgi?ISBN=' + @isbn.delete('-')
      else
        return 'http://bookweb.kinokuniya.co.jp/guest/cgi-bin/wshosea.cgi?W-ISBN=' + @isbn.delete('-')
      end
    end
  end
end

unless defined?(CacheBib_rakuten)
  class CacheBib_rakuten < CacheBib_temp
    def url_bibinfo
      rakuten_id = @affiliate_code.nil? ? '' : 'http://pt.afl.rakuten.co.jp/c/' + @affiliate_code + '/?url='
      return rakuten_id + 'http://books.rakuten.co.jp/bsearch/RBtitles.jsp?KEY=' + @isbn
    end
  end
end

unless defined?(CacheBib_skysoft)
  class CacheBib_skysoft < CacheBib_temp
    def url_bibinfo
      if @isbn =~ /^0/
        return 'http://www.skysoft.co.jp/GetTitleDetail.asp?C=2&ISBN=' + @isbn.delete('-')
      else
        return 'http://www.skysoft.co.jp/GetTitleDetail.asp?ISBN=' + @isbn
      end
    end
  end
end

# ISBN0

unless defined?(CacheBib_amazon_com)
  class CacheBib_amazon_com < CacheBib_temp
    def url_bibinfo
      return 'http://www.amazon.com/exec/obidos/ASIN/' + @isbn.delete('-') + '/'    end
  end
end

unless defined?(CacheBib_a1books)
  class CacheBib_a1books < CacheBib_temp
    def url_bibinfo
      return 'http://www.a1books.com/cgi-bin/a1Search?searchBy=isbn&searchStr=' + @isbn.delete('-')
    end
  end
end

unless defined?(CacheBib_powells)
  class CacheBib_powells < CacheBib_temp
    def url_bibinfo
      return 'http://www.powells.com/search/DTSearch/search?isbn=' + @isbn.delete('-')
    end
  end
end

unless defined?(CacheBib_maruzen)
  class CacheBib_maruzen < CacheBib_temp
    def url_bibinfo
      return 'http://www.maruzen.co.jp/cgi-bin/cgirelay/mis-ir-y1?isbn-1=' + @isbn.delete('-')
    end
  end
end

# ISBN1

unless defined?(CacheBib_amazon_uk)
  class CacheBib_amazon_uk < CacheBib_temp
    def url_bibinfo
      return 'http://www.amazon.co.uk/exec/obidos/ASIN/' + @isbn.delete('-')
    end
  end
end

unless defined?(CacheBib_bookshop)
  class CacheBib_bookshop < CacheBib_temp
    def url_bibinfo
      return 'http://www.bookshop.co.uk/ser/serpge.asp?I=' + @isbn.delete('-')
    end
  end
end

# 

unless defined?(CacheBib_esbooks)
  class CacheBib_esbooks < CacheBib_temp
    def url_bibinfo
      return 'http://www.esbooks.co.jp/search?isbn=' + @isbn
    end
  end
end

unless defined?(CacheBib_boople)
  class CacheBib_boople < CacheBib_temp
    def url_bibinfo
      return 'http://www.boople.com/servlet/AFsearch?iis=' + @isbn.delete('-')
    end
  end
end

unless defined?(CacheBib_rcom)
  class CacheBib_rcom < CacheBib_temp
    def url_bibinfo
      return 'http://popup7.tok2.com/home2/tanoshii/r_com/hq.htm'
    end
  end
end
