# $Id: link_rel.rb,v 1.6 2003/09/18 23:03:17 ogi Exp $
# 2003/09/22 C@tɂāAt@CɂΉÂ
=begin
link_rel.rb
	nDiary Plug-in : link rel ̑}
	(calenar.rb ɂȂĂ܂B)

	<!--plug=link_rel?title=%YN%m̓L?title_latest=ŋ߂̓L-->

	<link rel="first" title="yyyyNm̓L" href="@monthlyFilename" />
	<link rel="previous" title="yyyyNm̓L" href="@monthlyFilename" />
	<link rel="next" title="yyyyNm̓L" href="@monthlyFilename" />
		or
	<link rel="next" title="ŋ߂̓L" href="@latestFile" />
=end

def plug(opt)
  if RUBY_VERSION =~ /^1.8/
    require 'date'
  else
    begin
      require '../user/lib/date2'
    rescue LoadError
      require 'date'
    end
  end
  
  title_format = (opt['title'] or "%YN%m̓L")
  title_latest = (opt['title_latest'] or "ŋ߂̓L")
  
  if self.kind_of?(LastDiary) or self.kind_of?(Topics) then
    latest = true
  elsif self.kind_of?(PastDiary) then
    latest = false
  else
    return
  end
  
  today = @diaries[0]
  tailday = @diaries[-1]
  alldiaries = @allDiaries.keys.sort
  firstday = alldiaries.first
  prevday  = (alldiaries.index(today)-1).nil?   ? nil : alldiaries[alldiaries.index(today)-1]
  nextday  = (alldiaries.index(tailday)+1).nil? ? nil : alldiaries[alldiaries.index(tailday)+1]
  
  str = ''
  # first
  time = Time.mktime(firstday[0..3].to_i, firstday[4..5].to_i)
  str << "<link rel=\"first\" title=\"#{time.strftime2(title_format)}\" href=\"#{date2monthlyfilelink(firstday)}\" />\n"
  
  if latest then
    time = Time.mktime(today[0..3].to_i, today[4..5].to_i)
    str << "<link rel=\"previous\" title=\"#{time.strftime2(title_format)}\" href=\"#{date2monthlyfilelink(today)}\" />\n"
  else
    if !prevday.nil? then	# exists previouse
      time = Time.mktime(prevday[0..3].to_i, prevday[4..5].to_i)
      str << "<link rel=\"previous\" title=\"#{time.strftime2(title_format)}\" href=\"#{date2monthlyfilelink(prevday)}\" />\n"
    else			# is first
      # nothing
    end
    
    if !nextday.nil? then # exists next
      time = Time.mktime(nextday[0..3].to_i, nextday[4..5].to_i)
      str << "<link rel=\"next\" title=\"#{time.strftime2(title_format)}\" href=\"#{date2monthlyfilelink(nextday)}\" />\n"
    else			# is latest
      str << "<link rel=\"next\" title=\"#{title_latest}\" href=\"#{@latestFilename}\" />"
    end
  end
  
  return str
end
